var got = require('got');
const AWS = require('aws-sdk');
const S3_BUCKET = 'works.masterworks.io';

// var credentials = new AWS.SharedIniFileCredentials({ profile: 'masterworks' });
// AWS.config.credentials = credentials;
const s3 = new AWS.S3();

async function put(name, text) {
  return await s3
    .upload({
      Bucket: S3_BUCKET,
      Key: `caches/wikipedia/${name}.json`,
      Body: JSON.stringify(text),
      // ACL: 'public-read',
    })
    .promise();
}

async function get(name) {
  var result = await s3
    .getObject({
      Bucket: S3_BUCKET,
      Key: `caches/wikipedia/${name}.json`,
    })
    .promise();

  return JSON.parse(result.Body.toString());
}

function capitalize(string) {
  return string
    .toLowerCase()
    .replace(/(^|[^a-zA-Z\u00C0-\u017F'])([a-zA-Z\u00C0-\u017F])/g, function(
      m,
    ) {
      return m.toUpperCase();
    });
}

async function wikiFetch(name) {
  var body;
  try {
    body = await get(name);
  } catch (err) {
    console.log('err', err);

    var url = `https://en.wikipedia.org/w/api.php?format=json&action=query&prop=extracts&exintro&explaintext&redirects=1&titles=${capitalize(
      name,
    )}`;

    var res = await got(url, { json: true });

    await put(name, res.body);

    body = res.body;
  }

  var firstPage = Object.keys(body.query.pages)[0];
  let extract = body.query.pages[firstPage].extract;

  console.log('extract', extract);

  return (extract || '').replace(/;/g, '');
}

module.exports = wikiFetch;

async function main() {
  console.log(await wikiFetch('Salvador Dali'));
}

if (require.main === module) {
  main();
}
